<template>
  <div>
    <div v-if="!databaseLoad">
      <section class="pagesecond-front">
        <div class="container">
          <div class="pagesecond-front-main">
            <div class="pagesecond-front-main-title">
              <h1 v-if="database.title1.display || isAuthAdmin">
                <span :class="database.title1.display||'opacity-20 pointer-events-none'">{{database.title1.text}}</span>
                <q-popup-edit v-if="isAuthAdmin" v-model="database.title1.text" auto-save v-slot="scope">
                  <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                </q-popup-edit>
                <q-toggle
                  v-if="isAuthAdmin"
                  v-model="database.title1.display"
                  checked-icon="visibility"
                  color="green"
                  unchecked-icon="visibility_off"
                />
              </h1>
              <h2 v-if="database.subtitle1.display || isAuthAdmin">
                <span :class="database.subtitle1.display||'opacity-20 pointer-events-none'">{{database.subtitle1.text}}</span>
                <q-popup-edit v-if="isAuthAdmin" v-model="database.subtitle1.text" auto-save v-slot="scope">
                  <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                </q-popup-edit>
                <q-toggle
                  v-if="isAuthAdmin"
                  v-model="database.subtitle1.display"
                  checked-icon="visibility"
                  color="green"
                  unchecked-icon="visibility_off"
                />
              </h2>
            </div>
            <div class="pagesecond-front-main-container">
              <div v-if="database.video1.display || isAuthAdmin" class="pagesecond-front-main-foto">
<!--                https://www.youtube.com/watch?v=-->
<!--                <video controls :src="`http://www.youtube.com/embed/${database.video1.text}`" poster="../assets/image/pagesecond/video1.png"></video>-->
                <iframe v-if="!database.video1.image" type="text/html" width="100%" height="100%"
                        :class="database.video1.display||'opacity-20 pointer-events-none'"
                        :src="`https://www.youtube.com/embed/${database.video1.text}?rel=0&amp;controls=0`"
                        frameborder="0"/>
                <div v-else><q-img :src="database.video1.image.path" style="width: 100%; max-height: 400px" /></div>
                <div class="flex items-center" v-if="isAuthAdmin">
                  <q-toggle
                      v-if="isAuthAdmin"
                      v-model="database.video1.display"
                      checked-icon="visibility"
                      color="green"
                      unchecked-icon="visibility_off"
                  />
                  <span class="mr-4">Ссылка на ролик: <input v-model="database.video1.text" class="ml-2 text-right"></span>
                  <label v-if="!database.video1.image" class="add-image ml-4 cursor-pointer" for="1234">
                    <div class="bg-green text-white px-2 py-1 rounded">Добавить изображение</div>
                  </label>
                  <input v-on:change="addImagesTopBlock" id="1234" type="file" hidden>
                  <q-btn v-if="database.video1.image" @click="deleteImageTopBlock(database.video1.image.name)" label="удалить изображение" size="sm" color="red"/>
                </div>
              </div>

              <div v-if="database.video1.display || isAuthAdmin" class="pagesecond-front-main-items-container">
                <div :class="database.video1.display||'opacity-20 pointer-events-none'" class="pagesecond-front-main-items">
                  <div class="pagesecond-front-main-item-container">
                    <div class="pagesecond-front-main-item-first">
                      <div class="pagesecond-front-main-item-title">
                        <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item1.svg">
                        <div class="pagesecond-front-main-item-title-cont">
                          <h3><a href="">Получить бесплатно</a></h3>
                        </div>
                      </div>
                      <p class="pagesecond-front-main-item-text">решения и постановления судов по делам, аналогичным вашему</p>
                    </div>
                  </div>
                  <div class="pagesecond-front-main-item-container">
                    <div class="pagesecond-front-main-item-second">
                      <div class="pagesecond-front-main-item-title">
                        <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item2.svg">
                        <div class="pagesecond-front-main-item-title-cont">
                          <h3><a href="">Узнайте шансы</a></h3>
                        </div>
                      </div>
                      <p class="pagesecond-front-main-item-text">по своему делу на основе постановлений и решений судов</p>
                    </div>
                  </div>
                  <div class="pagesecond-front-main-item-container">
                    <div class="pagesecond-front-main-item-third">
                      <div class="pagesecond-front-main-item-title-third">
                        <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item3.svg">
                        <div class="pagesecond-front-main-item-title-cont">
                          <h3><a href="">Бесплатные ходатайства</a></h3>
                        </div>
                      </div>
                      <p class="pagesecond-front-main-item-text-third">по возврату прав</p>
                    </div>
                  </div>
                  <div class="pagesecond-front-main-item-container">
                    <div class="pagesecond-front-main-item-fourth">
                      <div class="pagesecond-front-main-item-title-fourth">
                        <img class="pagesecond-front-main-item-img" src="../assets/image/pagesecond/item4.svg">
                        <div class="pagesecond-front-main-item-title-cont">
                          <h3><a href="">Получить видеоинструкцию</a></h3>
                        </div>
                      </div>
                      <p class="pagesecond-front-main-item-text-fourth">по возврату прав</p>
                    </div>
                  </div>
                </div>
                <q-toggle
                  v-if="isAuthAdmin"
                  v-model="database.video1.display"
                  checked-icon="visibility"
                  color="green"
                  unchecked-icon="visibility_off"
                  class="float-right"
                />
              </div>
            </div>
            <div class="position-relative">
              <div v-if="database.block1.display || isAuthAdmin" class="pagesecond-front-main-law" :class="database.block1.display||'opacity-20'">
                <h2 v-if="database.block1.display || isAuthAdmin" class="pagesecond-front-main-law-title" style="width: 100%!important;">
                  <span>{{database.block1.title}}</span>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block1.title" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
                </h2>
                <div class="pagesecond-front-main-law-item">
                  <img class="pagesecond-front-main-law-item-img" src="../assets/image/pagesecond/warning.svg">
                  <p class="pagesecond-front-main-law-item-text">
                    {{database.block1.subtitle1}}
                    <q-popup-edit v-if="isAuthAdmin" v-model="database.block1.subtitle1" auto-save v-slot="scope">
                      <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                    </q-popup-edit>
                  </p>
                </div>
                <div class="pagesecond-front-main-law-item">
                  <img class="pagesecond-front-main-law-item-img" src="../assets/image/pagesecond/warning.svg">
                  <p class="pagesecond-front-main-law-item-text">
                    {{database.block1.subtitle2}}
                    <q-popup-edit v-if="isAuthAdmin" v-model="database.block1.subtitle2" auto-save v-slot="scope">
                      <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                    </q-popup-edit>
                  </p>
                </div>
              </div>
              <q-toggle
                v-if="isAuthAdmin"
                v-model="database.block1.display"
                checked-icon="visibility"
                color="green"
                unchecked-icon="visibility_off"
                class="float-right"
                style="transform: translate(0, -45px)"
              />
            </div>
          </div>
        </div>
      </section>
      <section class="container pagesecond-helper">
        <div v-if="database.block2.display || isAuthAdmin" class="pagesecond-helper-container" :class="database.block2.display||'opacity-20'">
          <h1>
            <span>{{database.block2.title}}</span>
            <q-popup-edit v-if="isAuthAdmin" v-model="database.block2.title" auto-save v-slot="scope">
              <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
            </q-popup-edit>
          </h1>
          <div class="pagesecond-helper-items">
            <div class="pagesecond-helper-items-container">
              <div
                v-for="(item, i) in database.block2.blocks"
                :key="`pagesecond-helper-items-container-${i}`"
                class="pagesecond-helper-items-item">
                <img class="desktop" src="../assets/image/pagesecond/tick_desk.svg">
                <img class="mobile" src="../assets/image/pagesecond/tick_mob.svg">
                <div class="pagesecond-helper-items-item-text">
                  <p>{{item}}</p>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block2.blocks[i]" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
                  <div class="pagesecond-helper-line-first"></div>
                </div>
              </div>
            </div>
          </div>
        </div>
        <q-toggle
          v-if="isAuthAdmin"
          v-model="database.block2.display"
          checked-icon="visibility"
          color="green"
          unchecked-icon="visibility_off"
          class="float-right"
        />
      </section>
      <section class="pagesecond-form">
        <div class="container pagesecond-front-form">
          <h3
              v-if="!database.form"
              @click="database.form = {title: 'Мы знаем 6 способов вернуть права за алкогольное опьянение', subtitle: 'Один из них точно подойдет к Вашей ситуации. Оставьте заявку и узнайте их'}"
              class="pagesecond-front-form-title"
          >Мы знаем 6 способов вернуть права за алкогольное опьянение</h3>
          <h3 v-else class="pagesecond-front-form-title">
            {{ database.form.title || 'Мы знаем 6 способов вернуть права за алкогольное опьянение' }}
          </h3>
          <h4 class="pagesecond-front-form-title-two">{{ database.form.subtitle || 'Один из них точно подойдет к Вашей ситуации. Оставьте заявку и узнайте их' }}</h4>
          <q-popup-edit v-if="isAuthAdmin" v-model="database.form" auto-save v-slot="scope">
            <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" label="Заголовок" v-model="scope.value.title" dense autofocus counter @keyup.enter="scope.set" />
            <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" label="Подзаголовок" v-model="scope.value.subtitle" dense autofocus counter @keyup.enter="scope.set" />
          </q-popup-edit>
          <div class="grid lg:grid-cols-4 gap-2 sm:grid-cols-3 sm:grid-cols-1 mt-2">

            <q-input v-model="form.name" color="prime-11" bg-color="white" filled  label="Имя" dense="dense" class="w-full mb-4" />
            <q-input v-model="form.email" color="prime-11" bg-color="white" filled  label="E-mail" dense="dense" class="w-full mb-4" />
            <q-input v-model="form.phone" color="prime-11" bg-color="white" filled  label="Телефон" dense="dense" class="w-full mb-4" />
            <q-btn
              @click="sendForm"
              color="yellow"
              class="text-black mr-auto"
              label="Узнать результаты"
              style="width: 300px; height: 40px"
            />
          </div>
          <div class="pagesecond-front-form-person">
            <span>Отправляя заявку вы соглашаетесь с <a href="">Условиями обработки персональных данных</a></span>
          </div>
        </div>
      </section>
      <section class=" pagesecond-stages">
        <div v-if="database.block3.display || isAuthAdmin" :class="database.block3.display||'opacity-20'" class="container pagesecond-stages-container">
          <h1>
            {{database.block3.title}}
            <q-popup-edit v-if="isAuthAdmin" v-model="database.block3.title" auto-save v-slot="scope">
              <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
            </q-popup-edit>
          </h1>
          <div class="pagesecond-stages-items">
            <div class="pagesecond-stages-items-container">
              <div v-for="(item, i) in database.block3.blocks" class="pagesecond-stages-items-item">
                <svg class="pagesecond-stages-items-item-svg" xmlns="http://www.w3.org/2000/svg" width="48" height="48" viewBox="0 0 48 48" fill="none">
                  <path d="M0 24C0 10.7452 10.7452 0 24 0C37.2548 0 48 10.7452 48 24C48 37.2548 37.2548 48 24 48C10.7452 48 0 37.2548 0 24Z" fill="white"/>
                  <path d="M0 24C0 10.7452 10.7452 0 24 0C37.2548 0 48 10.7452 48 24C48 37.2548 37.2548 48 24 48C10.7452 48 0 37.2548 0 24Z" fill="black" fill-opacity="0.75"/>
                  <path d="M22 30L28 24L22 18" stroke="white" stroke-width="1" stroke-linecap="round"/>
                </svg>
                <p class="pagesecond-stages-items-item-text">
                  {{item}}
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block3.blocks[i]" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
                </p>
              </div>
            </div>
          </div>
        </div>
        <q-toggle
          v-if="isAuthAdmin"
          v-model="database.block3.display"
          checked-icon="visibility"
          color="green"
          unchecked-icon="visibility_off"
          class="ml-auto mr-2"
        />
      </section>
      <section class="pagesecond-practice">
        <div v-if="database.block4.display || isAuthAdmin" :class="database.block4.display||'opacity-20'" class="container container__no__m">
          <div class="pagesecond-practice-container swiper">
            <div class="pagesecond-practice-title-container">
              <h1 class="pagesecond-practice-title" style="max-width: 900px">
                {{database.block4.title}}
                <q-popup-edit v-if="isAuthAdmin" v-model="database.block4.title" auto-save v-slot="scope">
                  <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                </q-popup-edit>
              </h1>
              <!-- <div class="pagesecond-practice-arrows desktop">
                  <img src="../assets/image/pagesecond/arrow_left.svg">
                  <img src="../assets/image/pagesecond/arrow_right.svg">
              </div> -->
              <div class="swiper__btns pagesecond-practice-arrows desktop">
                <img @click="$refs.carousel.previous()" src="../assets/image/pagesecond/arrow_left.svg" alt="" class="swiper-button-img-prev swiper-button-img">
                <img @click="$refs.carousel.next()" src="../assets/image/pagesecond/arrow_right.svg" alt="" class="swiper-button-img-next swiper-button-img">
              </div>
            </div>
            <div class="q-pa-md">
              <q-carousel
                v-if="!isAuthAdmin"
                v-model="slide"
                swipeable
                animated
                thumbnails
                infinite
                ref="carousel"
                navigation
                padding
                style="max-width: 350px; margin: 0 auto; height: 100%; min-height: 300px"
              >
                <q-carousel-slide v-for="(block, indexImage) in database.block4.blocks" :name="indexImage">
<!--                  <div class="row fit justify-start items-center justify-center q-gutter-xs q-col-gutter no-wrap">-->
<!--                    <q-img class="rounded-borders col-6 full-height" :src="block.path" />-->
<!--                  </div>-->
                  <div class="">
                    <q-img class="rounded-borders col-6 full-height" :src="block.path" />
                  </div>
                </q-carousel-slide>
              </q-carousel>
              <div v-else>
                <h6>Все изображения слайдера:</h6>
                <div class="block4-admin-image">
                  <div
                    v-for="(item, i) in database.block4.blocks"
                    :key="item"
                    class="col-2 m-2"
                  >
                    <q-img :src="item.path" width="150px">
                      <q-btn @click="deleteImage(item.name)"
                             color="red"
                             class="absolute-bottom all-pointer-events"
                             icon="delete"
                      >
                        <q-tooltip>
                          Удалить
                        </q-tooltip>
                      </q-btn>
                    </q-img>
                  </div>
                  <label class="add-image ml-4" for="123">
                    <span>
                      <q-icon name="add_box" size="lg" />
                      <q-tooltip>Добавить изображение</q-tooltip>
                    </span>
                  </label>
                  <input v-on:change="addImages" id="123" type="file" hidden>
                </div>
              </div>
            </div>

            <div class="swiper-pagination"></div>
          </div>
        </div>
        <q-toggle
          v-if="isAuthAdmin"
          v-model="database.block4.display"
          checked-icon="visibility"
          color="green"
          unchecked-icon="visibility_off"
          class="float-right"
        />
      </section>
      <section class="container pagesecond-others">
        <div class="pagesecond-others-container">
          <div class="pagesecond-others-container-first">
            <div v-for="(item, i) in database.block5.row1"
                 :key="`pagesecond-others-container-first-${item.title}`"
                 class="pagesecond-others-first-items"
                 :class="database.block5.row1[i].display||'opacity-20'"
            >
              <q-toggle
                v-if="isAuthAdmin"
                v-model="database.block5.row1[i].display"
                checked-icon="visibility"
                color="green"
                unchecked-icon="visibility_off"
                class="float-right ml-2 mt-1"
                dense
              />
              <h3 v-if="database.block5.row1[i].display||isAuthAdmin" class="pagesecond-others-first-items-title flex align-center" style="margin-top: 0;">
                {{item.title}}
                <q-popup-edit v-if="isAuthAdmin" v-model="database.block5.row1[i].title" auto-save v-slot="scope">
                  <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                </q-popup-edit>
              </h3>
              <div
                v-for="(el, el_i) in item.item"
                :key="`pagesecond-others-first-items-title-${el.name + el_i}`"
                class="pagesecond-others-first-items-item"
                style="flex-direction: row"
                :style="{border: isAuthAdmin && '1px dashed gray' || '0px', flexDirection: isAuthAdmin && 'column'}"
                v-show="el.display || isAuthAdmin"
              >
                <div v-if="isAuthAdmin" class="ml-auto">
                  <q-toggle
                    v-model="database.block5.row1[i].item[el_i].display"
                    checked-icon="visibility"
                    color="green"
                    unchecked-icon="visibility_off"
                    dense
                  />
                  <q-icon @click="database.block5.row1[i].item.splice(el_i, 1)" size="xs" name="close" class="cursor-pointer"/>
                </div>
                <div :class="database.block5.row1[i].item[el_i].display||'opacity-20'">
                  <router-link v-if="!isAuthAdmin && !el.is_external_reference" :to="el.path">{{el.name}}</router-link>
                  <a v-else-if="!isAuthAdmin && el.is_external_reference" :href="el.path" target="_blank">{{el.name}}</a>
                  <span v-else>{{el.name}}</span>
                  <q-popup-edit v-if="isAuthAdmin" v-model="database.block5.row1[i].item[el_i]" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value.name" dense autofocus counter @keyup.enter="scope.set" />
                    <q-input type="text" v-model="scope.value.path" dense counter @keyup.enter="scope.set" label="Ссылка"/>
                    <q-toggle :model-value="scope.value.is_external_reference" v-model="scope.value.is_external_reference" label="Внешняя ссылка" left-label/>
                  </q-popup-edit>
                </div>
              </div>
              <q-btn v-if="isAuthAdmin" @click="database.block5.row1[i].item.push({name: 'Пункт', path: '', display: true})" icon="add" rounded class="mt-1" />
            </div>
          </div>
          <div class="pagesecond-others-container-second">
            <div class="pagesecond-others-container-second-title">
              <h1 class="pagesecond-others-second-title">
                <span>{{database.block5.row2.title}}</span>
                <q-popup-edit v-if="isAuthAdmin" v-model="database.block5.row2.title" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
              </h1>
              <h3 class="pagesecond-others-second-title-two">
                <span>{{database.block5.row2.subtitle}}</span>
                <q-popup-edit v-if="isAuthAdmin" v-model="database.block5.row2.subtitle" auto-save v-slot="scope">
                    <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
                  </q-popup-edit>
              </h3>
            </div>
            <button v-if="isAuthAdmin" class="button-two" style="color: white; background-color: black; width: 70%; height: 45px; text-transform: uppercase">
              {{database.block5.row2.button}}
              <q-popup-edit v-if="isAuthAdmin" v-model="database.block5.row2.button" auto-save v-slot="scope">
                <q-input :type="scope.value.length > 100 && 'textarea' || 'text'" v-model="scope.value" dense autofocus counter @keyup.enter="scope.set" />
              </q-popup-edit>
            </button>
            <q-btn
              v-else
              color="black"
              class="text-white mx-auto mb-10"
              :label="database.block5.row2.button"
              size="16px"
              style="width: 300px"
            />
          </div>
        </div>
      </section>
      <section class="container pagesecond-consultation">
        <div class="pagesecond-consultation-container">
          <h1>Получите консультацию бесплатно</h1>
          <div class="pagesecond-consultation-inputs">
            <q-input v-model="form.note" color="yellow" class="w-full ml-2 pr-4" label="Введите ваш вопрос"/>
            <div class="pagesecond-consultation-inputs-items">
              <q-input v-model="form.name" color="yellow" label="Ваше имя" class="w-full mx-2"/>
              <q-input
                v-model="form.phone"
                color="yellow"
                label="+7"
                class="w-full mx-2"
              />
              <q-input v-model="form.email" color="yellow" label="E-mail" class="w-full mx-2"/>
            </div>
          </div>
          <div class="pagesecond-consultation-person">
            <p>Отправляя заявку вы соглашаетесь с <a href="">Условиями обработки персональных данных</a></p>
          </div>
          <q-btn
            color="yellow"
            class="text-black mx-auto mt-4 mb-10"
            label="Узнать результаты"
            size="16px"
            style="width: 300px"
            @click="sendForm"
          />
        </div>
      </section>
      <div v-if="isAuthAdmin" class="add-page-wrap grid grid-rows-1 gap-1">
        <q-btn @click="modalAddPage = true" color="white" class="text-black" size="md" icon-right="add" label="Добавить страницу"/>
        <q-btn @click="deletePage" color="red" class="text-black" size="md" icon-right="remove" label="Удалить"/>
      </div>
      <Modal v-if="modalAddPage" @close="modalAddPage = false">
        <template v-slot:body>
          <q-stepper
            v-if="!addPageCheck"
            v-model="step"
            vertical
            color="primary"
            animated
            dark
          >
            <q-step
              :name="1"
              title="Ознакомтесь с адресами страниц"
              icon="visibility"
              :done="step > 1"
            >
              <q-tree
                :nodes="databaseRouter"
                node-key="path"
                default-expand-all
                dark
              >
                <template v-slot:header-root="prop">
                  <div class="row items-center">
                    <div>
                      <q-badge class="q-ml-sm">
                        {{ prop.node.path }}
                      </q-badge>
                    </div>
                  </div>
                </template>
                <template v-slot:header-generic="prop">
                  <q-badge @click.stop class="q-ml-sm">
                    {{ prop.node.path }}
                  </q-badge>
                </template>
              </q-tree>
              <q-stepper-navigation>
                <q-btn @click="step = 2" label="Далее" class="float-right"/>
              </q-stepper-navigation>
            </q-step>

            <q-step
              :name="2"
              title="Придумайте адрес новой страницы"
              icon="create_new_folder"
              :done="step > 2"
            >
              <q-input v-model="pathNewPage.path" dark label="Введите адрес страницы" autofocus/>
              <q-stepper-navigation>
                <q-btn @click="addPage" label="Сохранить" class="float-right"/>
              </q-stepper-navigation>
            </q-step>
          </q-stepper>
          <div v-else>
            <q-icon size="xl" color="green" name="new_releases" />
            <p class="text-h6 my-6">Страница успешно добавлена!</p>

            <router-link target="_blank" :to="{name: 'Alko', params: {id: pathNewPage.path}}" replace>
              <q-btn @click="addPageCheck = false; modalAddPage = false" label="Перейти на страницу" icon-right="arrow_right" flat/>
            </router-link>
          </div>
        </template>
      </Modal>
    </div>

    <SendForm v-if="isSendForm" :form="form" />
  </div>
</template>

<script>
import {computed, onMounted, ref, watch} from "vue";
import { getDatabase, ref as firebaseRef, child, get, update } from "firebase/database";
import { getStorage, ref as firebaseStorageRef, getDownloadURL, uploadBytesResumable, deleteObject, listAll } from "firebase/storage";
import {useStore} from "vuex";
import {useRoute, useRouter} from "vue-router";
import Sceleton from "../../src/components/Skeleton.vue"
import Modal from "../../src/components/Modal.vue";
import SendForm from "../components/Send-form.vue";

export default {
  name: "Alko",
  components: {
    SendForm,
    Modal,
    Sceleton
  },
  setup () {
    const store = useStore();
    const route = useRoute();
    const router = useRouter();
    const db = getDatabase();
    const dbRef = firebaseRef(db);
    const storage = getStorage();
    let newObj = {}
    // const storageRef = firebaseStorageRef(storage, `${route.params.id_1}/${route.params.id_2}`);
    const database = ref({});
    const databaseRouter = ref([]);
    const databaseLoad = ref(true);

    async function getDatabaseFirebase() {
      await get(child(dbRef, `/narusheniya-i-zashchita/${route.params.id}`)).then((snapshot) => {
        if (snapshot.exists()) {
          database.value = snapshot.val()
          newObj = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });
      await get(child(dbRef, `/router`)).then((snapshot) => {
        if (snapshot.exists()) {
          databaseRouter.value = snapshot.val()
        } else {
          console.log("No data available");
        }
      }).catch((error) => {
        console.error(error);
      });

      databaseLoad.value = false
    }
    getDatabaseFirebase()

    const images = ref([]);
    async function addImages (event) {
      const input = event.target
      const file = input.files[0]

      // Проверяем, является ли файл изображением
      if (file.type.startsWith('image/')) {
        const uploadTask = uploadBytesResumable(firebaseStorageRef(storage, `page1/${file.name}`), file);
        uploadTask.on('state_changed',
          (snapshot) => {
            // Observe state change events such as progress, pause, and resume
            // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
            const progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
            console.log('Upload is ' + progress + '% done');
            switch (snapshot.state) {
              case 'paused':
                console.log('Upload is paused');
                break;
              case 'running':
                console.log('Upload is running');
                break;
            }
          },
          (error) => {
            // Handle unsuccessful uploads
          },
          () => {
            // Handle successful uploads on complete
            // For instance, get the download URL: https://firebasestorage.googleapis.com/...
            getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
              database.value.block4.blocks?.length && database.value.block4.blocks.push({name: file.name, path: downloadURL})
              || (database.value.block4.blocks = [{name: file.name, path: downloadURL}])
              console.log('File available at', downloadURL);
            });
          }
        );
      } else {
        return null
      }
    }
    async function addImagesTopBlock (event) {
      const input = event.target
      const file = input.files[0]

      // Проверяем, является ли файл изображением
      if (file.type.startsWith('image/')) {
        const uploadTask = uploadBytesResumable(firebaseStorageRef(storage, `page1/${file.name}`), file);
        uploadTask.on('state_changed',
          (snapshot) => {
            // Observe state change events such as progress, pause, and resume
            // Get task progress, including the number of bytes uploaded and the total number of bytes to be uploaded
            const progress = (snapshot.bytesTransferred / snapshot.totalBytes) * 100;
            console.log('Upload is ' + progress + '% done');
            switch (snapshot.state) {
              case 'paused':
                console.log('Upload is paused');
                break;
              case 'running':
                console.log('Upload is running');
                break;
            }
          },
          (error) => {
            // Handle unsuccessful uploads
          },
          () => {
            // Handle successful uploads on complete
            // For instance, get the download URL: https://firebasestorage.googleapis.com/...
            getDownloadURL(uploadTask.snapshot.ref).then((downloadURL) => {
              database.value.video1.image?.length && (database.value.video1.image = {name: file.name, path: downloadURL})
              || (database.value.video1.image = {name: file.name, path: downloadURL})
              console.log('File available at', downloadURL);
            });
          }
        );
      } else {
        return null
      }
    }

    async function deleteImage (desertRef) {
      deleteObject(firebaseStorageRef(storage, `page1/${desertRef}`)).then(() => {
        database.value.block4.blocks = database.value.block4.blocks.filter(el => el.name !== desertRef)
      })
    }
    async function deleteImageTopBlock (desertRef) {
      deleteObject(firebaseStorageRef(storage, `page1/${desertRef}`)).then(() => {
        database.value.video1.image = null
      })
    }

    const modalAddPage = ref(false)
    const pathNewPage = ref({path: '', header: 'generic'})

    const addPageCheck = ref(false)
    function addPage () {
      newObj.block4.blocks = []
      update(dbRef, {[`/narusheniya-i-zashchita/${pathNewPage.value.path}`]:newObj});
      update(dbRef, {[`/router/0/children/${databaseRouter.value[0].children.length}`]:{path: pathNewPage.value.path, header: 'generic'}});
      addPageCheck.value = true
    }
    function deletePage () {
      update(dbRef, {[route.path]:null});
      router.replace('/')
    }

    const isAuthAdmin = computed(() => store.getters.isAdmin && store.getters.isAuth)

    watch(database, ()=>{
      !databaseLoad.value && update(dbRef, {[`/narusheniya-i-zashchita/${route.params.id}`]: database.value});
    }, { deep: true })
    watch(route, async () => {
      await getDatabaseFirebase()
    })

    const form = ref({
      name: '',
      phone: '',
      email: '',
      note: '',
    })
    const isSendForm = ref(false);
    async function sendForm() {
      form.value.note = database.value.title1?.text
      isSendForm.value = true
    }

    return {
      route,
      isAuthAdmin,
      modalAddPage,
      slide: ref(0),
      question: ref(''),
      name: ref(''),
      phone: ref(''),
      email: ref(''),
      database,
      databaseRouter,
      databaseLoad,
      images,
      addImages,
      addImagesTopBlock,
      deleteImage,
      deleteImageTopBlock,
      addPage,
      deletePage,
      pathNewPage,
      addPageCheck,

      form,
      sendForm,isSendForm,

      step: ref(1),
    }
  }
}
</script>

<style scoped lang="scss">
@import "../assets/css/style_pagesecond_mobile.css";
@import "../assets/css/style_pagesecond_desktop.css";
.pagesecond-helper-items-container, .pagesecond-stages-items-container{
  display: grid;
  grid-template-columns: 1fr 1fr;
  grid-gap: 10px;
  margin-top: 20px;
  @media (max-width: 600px) {
    grid-template-columns: 1fr;
  }
  .pagesecond-helper-items-item, .pagesecond-stages-items-item {
    width: 100%;
  }
}
.block4-admin-image {
  display: flex;
  flex-wrap: wrap;
  align-items: center;
  justify-content: center;
  .add-image {
    width: 100px;
    display: flex;
    justify-content: center;
    align-items: center;
    background-color: #e7e7e7;
    border-radius: 4px;
    min-height: 150px;
  }
}
.pagesecond-others-container {
  @media (max-width: 1000px) {
    margin: 20px auto;
  }
  .pagesecond-others-container-first {
    width: 50%;
    display: grid;
    grid-gap: 10px;
    grid-template-columns: 1fr 1fr 1fr;
    @media (max-width: 1000px) {
      justify-items: center;
      width: 100%;
    }
  }
}
.add-page-wrap {
  position: fixed;
  bottom: 22px;
  left: 0px;
}
</style>
